<?php
	/**
	* TemplatePlazza
	* TemplatePlazza.com 
	**/
	defined( '_JEXEC' ) or die( 'Restricted access' );
	jimport('joomla.application.component.controller');
	jimport( 'joomla.application.component.helper' );
	jimport('joomla.filesystem.file');

	class TPshowcaseControllerShowcase extends JController{
		function __construct( $config = array() ){
			parent::__construct( $config );
			$this->registerTask( 'add',	'edit' );
		}
		
		function display($view = ''){
			$type = JRequest::getVar( 'type' );
			if(isset($type) && $type != ""){
				JRequest::setVar( 'view', $type );
			}
			parent::display();
		}
		
		function edit(){
			JRequest::setVar( 'view', 'showcase' );
			JRequest::setVar('hidemainmenu', 1);
			parent::display();
		}
		
		function cancel(){
			$this->setRedirect( 'index.php?option=com_tpshowcase&type=showcases' );
		}
		
		function save(){
			global $mainframe;
			
			$params				= JComponentHelper::getParams( 'com_tpshowcase' );
			$pathtosave			= str_replace("/",DS,$params->get('pathtosave'));
			$pathtosave			= JPATH_SITE . DS . $pathtosave . DS;
			
			$db					=& JFactory::getDBO();
			$id					= intval(JRequest::getString('id', '', 'request'));
			$name				= JRequest::getString('name', '', 'request');
			$email				= JRequest::getString('email', '', 'request');
			$url				= JRequest::getString('url', '', 'request');
			$title				= JRequest::getString('title', '', 'request');
			$desc				= JRequest::getString('desc', '', 'request');
			$thumb				= JRequest::getVar('thumb', '', 'files', 'thumb');
			$screen				= JRequest::getVar('screen', '', 'files', 'screen');
			$tags				= JRequest::getString('tags', '', 'request');
			$status				= JRequest::getString('status', '', 'request');
			$date				= date("Y-m-d H:i:s");
			$thumb['name']		= &JFile::makeSafe($thumb['name']); //make safe
			$screen['name']		= &JFile::makeSafe($screen['name']); //make safe
			
			if(!$id && (!isset($thumb['name']) || $thumb['name'] == "")){
				$mainframe->redirect("index.php?option=com_tpshowcase&type=showcases", JText::_('TP_ERROR_THUMB'));
				return false;
			}
			
			if(!$id && (!isset($screen['name']) || $screen['name'] == "")){
				$mainframe->redirect("index.php?option=com_tpshowcase&type=showcases", JText::_('TP_ERROR_SCREEN'));
				return false;
			}
			
			if(!$tags){
				$mainframe->redirect("index.php?option=com_tpshowcase&type=showcases", JText::_('TP_ERROR_TAGS'));
				return false;
			}
			
			//delete old files
			//========================
			if($id){
				$query	= "SELECT filename_thumb, filename_screen FROM #__tpshowcase_showcase WHERE id=" . $db->Quote($id);
				$db->setQuery($query);
				$olds	= $db->loadObject();
			}else{
				$olds	= NULL;
			}
			
			if($id && (isset($screen['name']) && $screen['name'] != "")){
				if($olds->filename_screen){
					JFILE::delete(JPath::clean($pathtosave.strtolower($olds->filename_screen)));
				}
			}
			
			if($id && (isset($thumb['name']) && $thumb['name'] != "")){
				if($olds->filename_thumb){
					JFILE::delete(JPath::clean($pathtosave.strtolower($olds->filename_thumb)));
				}
			}
			//========================
			
			$filepaththumb	= JPath::clean($pathtosave.strtolower($thumb['name']));
			$filepathscreen	= JPath::clean($pathtosave.strtolower($screen['name']));
				
			if((isset($thumb['name']) && $thumb['name'] != "") && !$this->canUpload( $thumb, $err )){
				$mainframe->redirect("index.php?option=com_tpshowcase&type=showcases", JText::_($err));
			}
			
			if((isset($screen['name']) && $screen['name'] != "") && !$this->canUpload( $screen, $err )){
				$mainframe->redirect("index.php?option=com_tpshowcase&type=showcases", JText::_($err));
			}
			
			//thumb
			if($thumb['name'] != ""){
				$newthumbname		= str_replace(".gif", "", $thumb['name']);
				$newthumbname		= str_replace(".jpg", "", $newthumbname);
				$newthumbname		= str_replace(".jpeg", "", $newthumbname);
				$newthumbname		= str_replace(".png", "", $newthumbname);
				$newthumbname		= str_replace(".", "", $newthumbname);
				$newthumbname		= str_replace(" ", "", $newthumbname);
				$newthumbname		= str_replace("-", "", $newthumbname);
				$newthumbname		= "thumb_" . strtolower(date('dMY_His')) . "_" . strtolower($newthumbname); //thumb_ + date + hour + original filename
				$uploadedthumb		= $thumb['tmp_name'];
				if($thumb['type'] == "image/gif"){
					$newthumbname		= $newthumbname . ".gif";
				}else if($thumb['type'] == "image/png"){
					$newthumbname		= $newthumbname . ".png";
				}else if($thumb['type'] == "image/jpg" || $thumb['type'] == "image/jpeg"){
					$newthumbname		= $newthumbname . ".jpg";
				}else{
					$mainframe->redirect("index.php?option=com_tpshowcase&type=showcases", JText::_('TP_ERROR_FILEEXT_NOTVALID'));
				}
				
				$newfilepath_thumb	= JPath::clean($pathtosave.strtolower($newthumbname));
				JFile::move($thumb['tmp_name'], $newfilepath_thumb);
				@rename($filepaththumb, $newfilepath_thumb); // renamefile
				@chmod($newfilepath_thumb, 0755); // change chmod
			}
			
			//screen
			if($screen['name'] != ""){
				$newscreenname		= str_replace(".gif", "", $screen['name']);
				$newscreenname		= str_replace(".jpg", "", $newscreenname);
				$newscreenname		= str_replace(".jpeg", "", $newscreenname);
				$newscreenname		= str_replace(".png", "", $newscreenname);
				$newscreenname		= str_replace(".", "", $newscreenname);
				$newscreenname		= str_replace(" ", "", $newscreenname);
				$newscreenname		= str_replace("-", "", $newscreenname);
				$newscreenname		= "screen_" . strtolower(date('dMY_His')) . "_" . strtolower($newscreenname); //screen_ + date + hour + original filename
				$uploadedscreen		= $screen['tmp_name'];
				if($screen['type'] == "image/gif"){
					$newscreenname		= $newscreenname . ".gif";
				}else if($screen['type'] == "image/png"){
					$newscreenname		= $newscreenname . ".png";
				}else if($screen['type'] == "image/jpg" || $screen['type'] == "image/jpeg"){
					$newscreenname		= $newscreenname . ".jpg";
				}else{
					$mainframe->redirect("index.php?option=com_tpshowcase&type=showcases", JText::_('TP_ERROR_FILEEXT_NOTVALID'));
				}
				
				$newfilepath_screen	= JPath::clean($pathtosave.strtolower($newscreenname));
				JFile::move($screen['tmp_name'], $newfilepath_screen);
				@rename($filepathscreen, $newfilepath_screen); // renamefile
				@chmod($newfilepath_screen, 0755); // change chmod
			}
										
			//save to database
			if(!$id){
				$q	= 	"INSERT INTO #__tpshowcase_showcase VALUES('','$name','$email','$url','$title','$newthumbname','$newscreenname','$desc','$tags','$date','$status')";
			}else{
				$tname	= (isset($thumb['name']) && $thumb['name'] != "") ? " filename_thumb='" . $newthumbname . "', " : "";
				$sname	= (isset($screen['name']) && $screen['name'] != "") ? " filename_screen='" . $newscreenname . "', " : "";
				$q	= "UPDATE #__tpshowcase_showcase SET fullname = '$name', email = '$email', url = '$url', title = '$title', $tname $sname description = '$desc', tag = '$tags', status = '$status' WHERE id=" . $db->Quote($id);
			}
			$db->setQuery($q);
			$db->Query();
			$mainframe->redirect("index.php?option=com_tpshowcase&type=showcases", $msg);
		}
		
		function canUpload( $file, &$err ){
			jimport('joomla.filesystem.file');
			if($file['name'] !== JFile::makesafe($file['name'])){
				$err = JText::_('TP_ERROR_FILENAME_NOTVALID!');
				return false;
			}
			
			$format = strtolower(JFile::getExt($file['name']));
	
			$allowable = explode( ',', "gif,jpg,jpeg,png");
			$ignored = explode(',', "bmp,exe,doc,zip,rar,xls,swf,html,html,php,asp,ppt,bat,pdf");
			if(!in_array($format, $allowable) && !in_array($format,$ignored)){
				$err = JText::_('TP_ERROR_FILEEXT_NOTVALID');
				return false;
			}
	
			$maxSize = 1000000; //max 1MB
			if($maxSize > 0 && (int) $file['size'] > $maxSize){
				$err = JText::_('TP_ERROR_FILEMAXSIZE_NOTVALID');
				return false;
			}
	
			$imginfo = null;
			if(true){
				$images = explode( ',', "gif,jpg,jpeg,png");
				if(($imginfo = getimagesize($file['tmp_name'])) === FALSE){
					$err = JText::_('TP_ERROR_FILENAME_NOTVALID');
					return false;
				}
			}
	
			$xss_check =  JFile::read($file['tmp_name'],false,256);
			$html_tags = array('abbr','acronym','address','applet','area','audioscope','base','basefont','bdo','bgsound','big','blackface','blink','blockquote','body','bq','br','button','caption','center','cite','code','col','colgroup','comment','custom','dd','del','dfn','dir','div','dl','dt','em','embed','fieldset','fn','font','form','frame','frameset','h1','h2','h3','h4','h5','h6','head','hr','html','iframe','ilayer','img','input','ins','isindex','keygen','kbd','label','layer','legend','li','limittext','link','listing','map','marquee','menu','meta','multicol','nobr','noembed','noframes','noscript','nosmartquotes','object','ol','optgroup','option','param','plaintext','pre','rt','ruby','s','samp','script','select','server','shadow','sidebar','small','spacer','span','strike','strong','style','sub','sup','table','tbody','td','textarea','tfoot','th','thead','title','tr','tt','ul','var','wbr','xml','xmp','!DOCTYPE', '!--');
			foreach($html_tags as $tag){
				// A tag is '<tagname ', so we need to add < and a space or '<tagname>'
				if(stristr($xss_check, '<'.$tag.' ') || stristr($xss_check, '<'.$tag.'>')){
					$err = 'WARNIEXSS';
					return false;
				}
			}
			return true;
		}
	}
?>